<!--
~ Copyright (c) WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~    http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied.  See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->
<%@ page import="org.wso2.carbon.identity.sso.agent.bean.LoggedInSessionBean" %>
<%@ page import="org.wso2.carbon.identity.sso.agent.SSOAgentConstants" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" pageEncoding="UTF-8" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>Italiano</title>

    <meta name="description" content="">
    <meta name="theme-color" content="#444444">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="shortcut icon" href="img/favicon.png">
    <link rel="apple-touch-icon" sizes="57x57" href="img/apple-touch-icon.png">
    <link rel="apple-touch-icon" sizes="72x72" href="img/apple-touch-icon-72x72.png">
    <link rel="apple-touch-icon" sizes="114x114" href="img/apple-touch-icon-114x114.png">
    <link rel="stylesheet" href="css/bootstrap.min.css">
    <link rel="stylesheet" href="css/styles.css">
</head>
<%
    String domin =  (String)session.getAttribute("tenantDomain");
    String claimedId = null;
    String subjectId = null;
    if(request.getSession(false) != null &&
            request.getSession(false).getAttribute(SSOAgentConstants.SESSION_BEAN_NAME) == null){
        request.getSession(false).invalidate();
%>
<script type="text/javascript">
    location.href = "index.jsp?tenantDomain=<%=domin%>";
</script>
<%
        return;
    }
    LoggedInSessionBean sessionBean = (LoggedInSessionBean)session.getAttribute(SSOAgentConstants.SESSION_BEAN_NAME);
    if(sessionBean != null){
        if(sessionBean.getOpenId() != null) {
            claimedId = sessionBean.getOpenId().getClaimedId();

        } else if(sessionBean.getSAML2SSO() != null) {
            subjectId = sessionBean.getSAML2SSO().getSubjectId();

        } else {
%>
<script type="text/javascript">
    location.href = "index.jsp?tenantDomain=<%=domin%>";
</script>
<%
        return;
    }
} else {
%>
<script type="text/javascript">
    location.href = "index.jsp?tenantDomain=<%=domin%>";
</script>
<%
        return;
    }
%>
<body>
<div class="banner">
    <div class="header">
        <div class="header-inner container clear">
            <a class="logo" href="#"><span class="sr">Italiano</span></a>
            <input type="checkbox" id="navigation-toggle-checkbox" name="navigation-toggle-checkbox" class="navigation-toggle-checkbox sr">
            <label for="navigation-toggle-checkbox" class="navigation-toggle-label" onclick>
        <span class="navigation-toggle-label-inner">
          <span class="sr">Navigation</span>
        </span>
            </label>
            <div class="user-menu">

                Welcome  <%
                if(subjectId != null){
            %>
                <%=subjectId %>
                <%
                } else if (claimedId != null) {
                %>
                <%=claimedId%>
                <%
                    }
                %>

                <a href="logout?SAML2.HTTPBinding=HTTP-POST">Logout</a>
            </div>
            <div class="navigation">
                <ul class="navigation-menu">
                    <li class="navigation-item"><a href="#about">About</a></li>
                    <li class="navigation-item"><a href="#ingredients">Ingredients</a></li>
                    <li class="navigation-item"><a href="#menu">Menu</a></li>
                    <li class="navigation-item"><a href="#reviews">Reviews</a></li>
                    <li class="navigation-item"><a href="#reservations">Reservations</a></li>
                </ul>
            </div>
        </div>
    </div>
    <div class="banner-inner container">
        <h1 class="banner-lead">
            <span class="banner-lead-1">the right ingredients</span>
            <span class="banner-lead-2">for the right food</span>
        </h1>
        <div class="banner-buttons">
            <a href="#reservations" class="button button-primary">Book a table</a>
            <a href="#menu" class="button button-secondary">See the menu</a>
        </div>
    </div>
</div>

<div id="about" class="content-block about-block">
    <div class="about-block-inner container">
        <div class="clear text-center">
            <div class="about-block-content col-6-l">
                <h2 class="heading">Just the right food</h2>
                <p>
                    If you've been to one of our restaurants, you've seen - and tasted - what keeps our customers coming back for more. <br>
                    Perfect materials and freshly baked food, delicious Lambda cakes, muffins, and gourmet coffees makes us hard to resist! <br>
                    Stop in today and check us out!
                </p>
                <img class="img-fluid about-chef" src="img/chef.png" alt="Chef">
            </div>
            <div class="about-block-img col-6-l none-m block-l">
                <img class="img-fluid" src="img/dish.png" alt="Dish of food">
            </div>
        </div>
    </div>
</div>

<div id="ingredients" class="content-block ingredients-block">
    <div class="ingredients-block-inner container clear">
        <div class="feature-box text-center col-6-l right-m">
            <h2 class="heading-secondary">Fine ingredients</h2>
            <div class="feature-box-content">
                <p>
                    If you've been to one of our restaurants, you've seen - and tasted - what keeps our customers coming back for more. <br>
                    Perfect materials and freshly baked food, delicious Lambda cakes, muffins, and gourmet coffees makes us hard to resist! <br>
                    Stop in today and check us out!
                </p>
                <div class="feature-image-group clear">
                    <img class="img-fluid feature-image feature-image-1" src="img/01-wheat.jpg" alt="Wheat">
                    <img class="img-fluid feature-image feature-image-2" src="img/02-spices.jpg" alt="Spices">
                    <img class="img-fluid feature-image feature-image-3" src="img/03-bread.jpg" alt="Bread">
                </div>
            </div>
        </div>
    </div>
</div>


<div id="menu" class="content-block food-menu-block">
    <div class="food-menu-block-inner container">
        <div class="clear">
            <div class="food-menu-content">
                <h2 class="heading">Appetisers</h2>
                <ul class="food-menu-list">
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Tzatski</h3>
                            <span class="food-menu-price">$3.99</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Refreshing traditional cucumber and garlic in yoghurt dip.
                            </p>
                        </div>
                    </li>
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Aubergine Salad</h3>
                            <span class="food-menu-price">$5.50</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Pureed eggplant garlic, green pepper and tomato dip.
                            </p>
                        </div>
                    </li>
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Aubergine Salad</h3>
                            <span class="food-menu-price">$5.25</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Pureed eggplant garlic, green pepper and tomato dip.
                            </p>
                        </div>
                    </li>
                </ul>

                <h2 class="heading">Salads</h2>
                <ul class="food-menu-list">
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Olive Special</h3>
                            <span class="food-menu-price">$5.99</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Refreshing traditional cucumber and garlic in yoghurt dip.
                            </p>
                        </div>
                    </li>
                    <li class="food-menu-item food-menu-item-special">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Greek Salad</h3>
                            <span class="food-menu-price">$5.50</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Pureed eggplant garlic, green pepper and tomato dip.
                            </p>
                        </div>
                    </li>
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Gusto Salad</h3>
                            <span class="food-menu-price">$5.25</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Pureed eggplant garlic, green pepper and tomato dip.
                            </p>
                        </div>
                    </li>
                </ul>
            </div>
            <div class="food-menu-content">
                <h2 class="heading">Starters</h2>
                <ul class="food-menu-list">
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Haloumi</h3>
                            <span class="food-menu-price">$3.99</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Refreshing traditional cucumber and garlic in yoghurt dip.
                            </p>
                        </div>
                    </li>
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Spinach Pie</h3>
                            <span class="food-menu-price">$5.50</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Pureed eggplant garlic, green pepper and tomato dip.
                            </p>
                        </div>
                    </li>
                </ul>

                <h2 class="heading">Main Dishes</h2>
                <ul class="food-menu-list">
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Cornish Mackerel</h3>
                            <span class="food-menu-price">$5.99</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Refreshing traditional cucumber and garlic in yoghurt dip.
                            </p>
                        </div>
                    </li>
                    <li class="food-menu-item food-menu-item-special">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Roast Lamb</h3>
                            <span class="food-menu-price">$5.50</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Pureed eggplant garlic, green pepper and tomato dip.
                            </p>
                        </div>
                    </li>
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Fried Chicken</h3>
                            <span class="food-menu-price">$5.25</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Pureed eggplant garlic, green pepper and tomato dip.
                            </p>
                        </div>
                    </li>
                    <li class="food-menu-item">
                        <div class="food-menu-item-header clear">
                            <h3 class="food-menu-heading">Pastitsio</h3>
                            <span class="food-menu-price">$5.99</span>
                        </div>
                        <div class="food-menu-summary">
                            <p>
                                Pureed eggplant garlic, green pepper and tomato dip.
                            </p>
                        </div>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</div>


<div id="reviews" class="content-block reviews-block">
    <div class="reviews-block-inner container">
        <div class="feature-box text-center col-12-m col-8-l no-float center">
            <h2 class="heading-secondary">Guest Reviews</h2>
            <blockquote class="pad-30">
                <p>
                    If you've been to one of our restaurants, you've seen - and tasted - what keeps our customers coming back for more.
                    Perfect materials and freshly baked food, delicious Lambda cakes, muffins, and gourmet coffees makes us hard to resist!
                    Stop in today and check us out!
                </p>
                <cite>
                    food inc, New York
                </cite>
            </blockquote>
        </div>
    </div>
</div>



<div id="reservations" class="content-block reservations-block">
    <div class="reservations-block-inner container">
        <div class="clear">
            <div class="reservation-block-img col-3-l none block-l">
                <img class="img-fluid " src="img/food-01.jpg" alt="Food">
            </div>
            <div class="reservation-block-img col-6-m col-3-l none block-m">
                <img class="img-fluid " src="img/food-02.jpg" alt="Food">
            </div>
            <div class="reservation-block-form col-6-m">
                <div class="text-center">
                    <h2 class="heading">Just the right food</h2>
                    <p>
                        If you've been to one of our restaurants, you've seen - and tasted - what keeps our customers coming back for more. Perfect materials and freshly baked food
                    </p>
                </div>
                <form class="reservations-form">
                    <fieldset class="reservations-form-wrap">
                        <legend class="sr">Contact Us</legend>
                        <div class="clear">
                            <div class="col-6-m pad-top-10 pad-bottom-10">
                                <label class="block strong" for="name">Name</label>
                                <input name="full-name" class="field" id="name" type="text" placeholder="your name *">
                            </div>
                            <div class="col-6-m pad-top-10 pad-bottom-10">
                                <label class="block strong" for="email">Email</label>
                                <input name="email" class="field" id="email" type="email" placeholder="your email *">
                            </div>
                        </div>
                        <div class="clear">
                            <div class="col-6-m pad-top-10 pad-bottom-10">
                                <label class="block strong" for="date">Date</label>
                                <input name="date-of-booking" class="field" id="date" type="text" placeholder="date *">
                            </div>
                            <div class="col-6-m pad-top-10 pad-bottom-10">
                                <label class="block strong" for="party-size">Party size</label>
                <span class="select">
                  <select class="field" name="party-size" id="party-size">
                    <option value="1">1</option>
                    <option value="2">2</option>
                    <option value="3">3</option>
                  </select>
                </span>
                            </div>
                        </div>
                        <div class="text-center">
                            <input type="submit" class="button reservations-submit" value="Book now!">
                        </div>
                    </fieldset>
                </form>
            </div>
        </div>
    </div>
</div>



<div class="footer">
    <div class="footer-inner container">
        <div class="clear">
            <div class="footer-column col-4-l">
                <h3 class="footer-heading">About us</h3>
                <p>
                    Lambda's new and expanded Chelsea location represents a truly <strong>authentic</strong> Greek
                    patisserie, featuring breakfasts of fresh croissants and steaming bowls of caf&eacute;.
                </p>
            </div>
            <div class="footer-column col-4-l">
                <h3 class="footer-heading">Opening Hours</h3>
                <p>
                    <strong>Mon-Thu:</strong> 7.00am - 8.00pm <br>
                    <strong>Fri-Sun:</strong> 7.00am - 10.00pm
                </p>
                <ul class="payment-types icon-list-inline">
                    <li><span class="payment payment-mastercard"><span class="sr">Mastercard</span></a></li>
                    <li><span class="payment payment-visa"><span class="sr">Visa</span></span></li>
                    <li><span class="payment payment-american-express"><span class="sr">American Express</span></span></li>
                    <li><span class="payment payment-paypal"><span class="sr">PayPal</span></span></li>
                </ul>
            </div>
            <div class="footer-column col-4-l">
                <h3 class="footer-heading">Our Location</h3>
                <p>
                    19th Paradise Street Sitia <br>
                    128 Meserole Avenue
                </p>
                <ul class="footer-social-list icon-list-inline">
                    <li class="navigation-item-social"><a class="social social-twitter" href="#"><span class="sr">Twitter</span></a></li>
                    <li class="navigation-item-social"><a class="social social-facebook" href="#"><span class="sr">Facebook</span></a></li>
                    <li class="navigation-item-social"><a class="social social-google-plus" href="#"><span class="sr">Google Plus</span></a></li>
                    <li class="navigation-item-social"><a class="social social-youtube" href="#"><span class="sr">YouTube</span></a></li>
                </ul>
            </div>
        </div>
        <div class="footer-logo">
            Powered by <a href=""> WSO2 Identity Server </a>
        </div>
    </div>
</div>

<script src="js/vendor/wow.js"></script>
<script src="js/vendor/webfontloader.js"></script>
<script src="js/default.js"></script>
<script src="js/jquery.js"></script>
<script src="js/bootstrap.min.js"></script>
</body>
</html>